Index: LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cv3a_uncompress.F90	(revision 2298)
@@ -1,19 +1,30 @@
-SUBROUTINE cv3a_uncompress(nloc, len, ncum, nd, ntra, idcum, iflag, kbas, &
-    ktop, precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, ft, fq, fu, fv, &
-    ftra, sigd, ma, mip, vprecip, upwd, dnwd, dnwd0, qcondc, wd, cape, cin, &
-    tvp, ftd, fqd, plim1, plim2, asupmax, supmax0, asupmaxmin &
-    , da, phi, mp, phi2, d1a, dam, sigij & ! RomP+AC+jyg
-    , clw, elij, evap, ep, epmlmmm, eplamm & ! RomP
-    , wdtraina, wdtrainm &         ! RomP
-    , qtc, sigt          &
-
-    , iflag1, kbas1, ktop1, precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, &
-    ptop21, ft1, fq1, fu1, fv1, ftra1, sigd1, ma1, mip1, vprecip1, upwd1, &
-    dnwd1, dnwd01, qcondc1, wd1, cape1, cin1, tvp1, ftd1, fqd1, plim11, &
-    plim21, asupmax1, supmax01, asupmaxmin1 &
-    , da1, phi1, mp1, phi21, d1a1, dam1, sigij1 & ! RomP+AC+jyg
-    , clw1, elij1, evap1, ep1, epmlmmm1, eplamm1 & ! RomP
-    , wdtraina1, wdtrainm1 & ! RomP
-    , qtc1, sigt1)
+SUBROUTINE cv3a_uncompress(nloc, len, ncum, nd, ntra, idcum, compress, &
+                           iflag, kbas, ktop, &
+                           precip, cbmf, plcl, plfc, wbeff, sig, w0, ptop2, &
+                           ft, fq, fu, fv, ftra,  &
+                           sigd, ma, mip, vprecip, upwd, dnwd, dnwd0, &
+                           qcondc, wd, cape, cin, &
+                           tvp, &
+                           ftd, fqd, &
+                           plim1, plim2, asupmax, supmax0, &
+                           asupmaxmin, &
+                           da, phi, mp, phi2, d1a, dam, sigij, &                ! RomP+AC+jyg
+                           clw, elij, evap, ep, epmlmMm, eplaMm, &              ! RomP
+                           wdtrainA, wdtrainM, &                                ! RomP
+                           qtc, sigt,          &
+                         
+                           iflag1, kbas1, ktop1, &
+                           precip1, cbmf1, plcl1, plfc1, wbeff1, sig1, w01, ptop21, &
+                           ft1, fq1, fu1, fv1, ftra1, &
+                           sigd1, ma1, mip1, vprecip1, upwd1, dnwd1, dnwd01, &
+                           qcondc1, wd1, cape1, cin1, &
+                           tvp1, &
+                           ftd1, fqd1, &
+                           plim11, plim21, asupmax1, supmax01, &
+                           asupmaxmin1, &
+                           da1, phi1, mp1, phi21, d1a1, dam1, sigij1, &         ! RomP+AC+jyg
+                           clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &        ! RomP
+                           wdtrainA1, wdtrainM1, &                              ! RomP
+                           qtc1, sigt1)
 
   ! **************************************************************
@@ -31,161 +42,246 @@
 
   ! inputs:
-  INTEGER nloc, len, ncum, nd, ntra
-  INTEGER idcum(nloc)
-  INTEGER iflag(nloc), kbas(nloc), ktop(nloc)
-  REAL precip(nloc), cbmf(nloc), plcl(nloc), plfc(nloc)
-  REAL wbeff(len)
-  REAL sig(nloc, nd), w0(nloc, nd), ptop2(nloc)
-  REAL ft(nloc, nd), fq(nloc, nd), fu(nloc, nd), fv(nloc, nd)
-  REAL ftra(nloc, nd, ntra)
-  REAL sigd(nloc)
-  REAL ma(nloc, nd), mip(nloc, nd), vprecip(nloc, nd+1)
-  REAL upwd(nloc, nd), dnwd(nloc, nd), dnwd0(nloc, nd)
-  REAL qcondc(nloc, nd)
-  REAL wd(nloc), cape(nloc), cin(nloc)
-  REAL tvp(nloc, nd)
-  REAL ftd(nloc, nd), fqd(nloc, nd)
-  REAL plim1(nloc), plim2(nloc)
-  REAL asupmax(nloc, nd), supmax0(nloc)
-  REAL asupmaxmin(nloc)
-
-  REAL da(nloc, nd), phi(nloc, nd, nd) !AC!
-  REAL mp(nloc, nd) !RomP
-  REAL phi2(nloc, nd, nd) !RomP
-  REAL d1a(nloc, nd), dam(nloc, nd) !RomP
-  REAL sigij(nloc, nd, nd) !RomP
-  REAL clw(nloc, nd), elij(nloc, nd, nd) !RomP
-  REAL evap(nloc, nd), ep(nloc, nd) !RomP
-  REAL epmlmmm(nloc, nd, nd), eplamm(nloc, nd) !RomP+jyg
-  REAL qtc(nloc, nd), sigt(nloc, nd) !RomP
-  REAL wdtraina(nloc, nd), wdtrainm(nloc, nd) !RomP
+  INTEGER, INTENT (IN)                               :: nloc, len, ncum, nd, ntra
+  INTEGER, DIMENSION (nloc), INTENT (IN)             :: idcum(nloc)
+!jyg<
+  LOGICAL, INTENT (IN)                               :: compress
+!>jyg
+  INTEGER, DIMENSION (nloc), INTENT (IN)             ::iflag, kbas, ktop
+  REAL, DIMENSION (nloc), INTENT (IN)                :: precip, cbmf, plcl, plfc
+  REAL, DIMENSION (nloc), INTENT (IN)                :: wbeff
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: sig, w0
+  REAL, DIMENSION (nloc), INTENT (IN)                :: ptop2
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ft, fq, fu, fv
+  REAL, DIMENSION (nloc, nd, ntra), INTENT (IN)      :: ftra
+  REAL, DIMENSION (nloc), INTENT (IN)                :: sigd
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ma, mip
+  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: vprecip
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: upwd, dnwd, dnwd0
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qcondc
+  REAL, DIMENSION (nloc), INTENT (IN)                :: wd, cape, cin
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: tvp
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: ftd, fqd
+  REAL, DIMENSION (nloc), INTENT (IN)                :: plim1, plim2
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: asupmax
+  REAL, DIMENSION (nloc), INTENT (IN)                :: supmax0, asupmaxmin
+
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: da
+  REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: phi                    !AC!
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: mp                     !RomP
+  REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: phi2                   !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: d1a, dam               !RomP
+  REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: sigij                  !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: clw                    !RomP
+  REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: elij                   !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: evap, ep               !RomP
+  REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: epmlmMm                !RomP+jyg
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: eplamM                 !RomP+jyg
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qtc, sigt              !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wdtrainA, wdtrainM     !RomP
 
   ! outputs:
-  INTEGER iflag1(len), kbas1(len), ktop1(len)
-  REAL precip1(len), cbmf1(len), plcl1(nloc), plfc1(nloc)
-  REAL wbeff1(len)
-  REAL sig1(len, nd), w01(len, nd), ptop21(len)
-  REAL ft1(len, nd), fq1(len, nd), fu1(len, nd), fv1(len, nd)
-  REAL ftra1(len, nd, ntra)
-  REAL sigd1(len)
-  REAL ma1(len, nd), mip1(len, nd), vprecip1(len, nd+1)
-  REAL upwd1(len, nd), dnwd1(len, nd), dnwd01(len, nd)
-  REAL qcondc1(len, nd)
-  REAL wd1(len), cape1(len), cin1(len)
-  REAL tvp1(len, nd)
-  REAL ftd1(len, nd), fqd1(len, nd)
-  REAL plim11(len), plim21(len)
-  REAL asupmax1(len, nd), supmax01(len)
-  REAL asupmaxmin1(len)
-
-  REAL da1(nloc, nd), phi1(nloc, nd, nd) !AC!
-  REAL mp1(nloc, nd) !RomP
-  REAL phi21(nloc, nd, nd) !RomP
-  REAL d1a1(nloc, nd), dam1(nloc, nd) !RomP
-  REAL sigij1(len, nd, nd) !RomP
-  REAL clw1(len, nd), elij1(len, nd, nd) !RomP
-  REAL evap1(len, nd), ep1(len, nd) !RomP
-  REAL epmlmmm1(len, nd, nd), eplamm1(len, nd) !RomP+jyg
-  REAL qtc1(len, nd), sigt1(len, nd) !RomP
-  REAL wdtraina1(len, nd), wdtrainm1(len, nd) !RomP
+  INTEGER, DIMENSION (len), INTENT (OUT)             :: iflag1, kbas1, ktop1
+  REAL, DIMENSION (len), INTENT (OUT)                :: precip1, cbmf1, plcl1, plfc1
+  REAL, DIMENSION (len), INTENT (OUT)                :: wbeff1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: sig1, w01
+  REAL, DIMENSION (len), INTENT (OUT)                :: ptop21
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ft1, fq1, fu1, fv1
+  REAL, DIMENSION (len, nd, ntra), INTENT (OUT)      :: ftra1
+  REAL, DIMENSION (len), INTENT (OUT)                :: sigd1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ma1, mip1
+  REAL, DIMENSION (len, nd+1), INTENT (OUT)          :: vprecip1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: upwd1, dnwd1, dnwd01
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qcondc1
+  REAL, DIMENSION (len), INTENT (OUT)                :: wd1, cape1, cin1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: tvp1
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: ftd1, fqd1
+  REAL, DIMENSION (len), INTENT (OUT)                :: plim11, plim21
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: asupmax1
+  REAL, DIMENSION (len), INTENT (OUT)                :: supmax01, asupmaxmin1
+                                                    
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: da1
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi1                   !AC!
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: mp1                    !RomP
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: phi21                  !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: d1a1, dam1 !RomP       !RomP
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: sigij1                 !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: clw1                   !RomP
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: elij1                  !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: evap1, ep1             !RomP
+  REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: epmlmMm1               !RomP+jyg
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplamM1                !RomP+jyg
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1, sigt1            !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainM1   !RomP
 
 
   ! local variables:
   INTEGER i, k, j
+  INTEGER jdcum
   ! c    integer k1,k2
 
-  DO i = 1, ncum
-    ptop21(idcum(i)) = ptop2(i)
-    sigd1(idcum(i)) = sigd(i)
-    precip1(idcum(i)) = precip(i)
-    cbmf1(idcum(i)) = cbmf(i)
-    plcl1(idcum(i)) = plcl(i)
-    plfc1(idcum(i)) = plfc(i)
-    wbeff1(idcum(i)) = wbeff(i)
-    iflag1(idcum(i)) = iflag(i)
-    kbas1(idcum(i)) = kbas(i)
-    ktop1(idcum(i)) = ktop(i)
-    wd1(idcum(i)) = wd(i)
-    cape1(idcum(i)) = cape(i)
-    cin1(idcum(i)) = cin(i)
-    plim11(idcum(i)) = plim1(i)
-    plim21(idcum(i)) = plim2(i)
-    supmax01(idcum(i)) = supmax0(i)
-    asupmaxmin1(idcum(i)) = asupmaxmin(i)
-  END DO
-
-  DO k = 1, nd
+!jyg<
+  IF (compress) THEN
+!>jyg
     DO i = 1, ncum
-      sig1(idcum(i), k) = sig(i, k)
-      w01(idcum(i), k) = w0(i, k)
-      ft1(idcum(i), k) = ft(i, k)
-      fq1(idcum(i), k) = fq(i, k)
-      fu1(idcum(i), k) = fu(i, k)
-      fv1(idcum(i), k) = fv(i, k)
-      ma1(idcum(i), k) = ma(i, k)
-      mip1(idcum(i), k) = mip(i, k)
-      vprecip1(idcum(i), k) = vprecip(i, k)
-      upwd1(idcum(i), k) = upwd(i, k)
-      dnwd1(idcum(i), k) = dnwd(i, k)
-      dnwd01(idcum(i), k) = dnwd0(i, k)
-      qcondc1(idcum(i), k) = qcondc(i, k)
-      tvp1(idcum(i), k) = tvp(i, k)
-      ftd1(idcum(i), k) = ftd(i, k)
-      fqd1(idcum(i), k) = fqd(i, k)
-      asupmax1(idcum(i), k) = asupmax(i, k)
-
-      da1(idcum(i), k) = da(i, k) !AC!
-      mp1(idcum(i), k) = mp(i, k) !RomP
-      d1a1(idcum(i), k) = d1a(i, k) !RomP
-      dam1(idcum(i), k) = dam(i, k) !RomP
-      clw1(idcum(i), k) = clw(i, k) !RomP
-      evap1(idcum(i), k) = evap(i, k) !RomP
-      ep1(idcum(i), k) = ep(i, k) !RomP
-      eplamm(idcum(i), k) = eplamm(i, k) !RomP+jyg
-      wdtraina1(idcum(i), k) = wdtraina(i, k) !RomP
-      wdtrainm1(idcum(i), k) = wdtrainm(i, k) !RomP
-      qtc1(idcum(i), k) = qtc(i, k)
-      sigt1(idcum(i), k) = sigt(i, k)
-
+      sig1(idcum(i), nd) = sig(i, nd)
+      ptop21(idcum(i)) = ptop2(i)
+      sigd1(idcum(i)) = sigd(i)
+      precip1(idcum(i)) = precip(i)
+      cbmf1(idcum(i)) = cbmf(i)
+      plcl1(idcum(i)) = plcl(i)
+      plfc1(idcum(i)) = plfc(i)
+      wbeff1(idcum(i)) = wbeff(i)
+      iflag1(idcum(i)) = iflag(i)
+      kbas1(idcum(i)) = kbas(i)
+      ktop1(idcum(i)) = ktop(i)
+      wd1(idcum(i)) = wd(i)
+      cape1(idcum(i)) = cape(i)
+      cin1(idcum(i)) = cin(i)
+      plim11(idcum(i)) = plim1(i)
+      plim21(idcum(i)) = plim2(i)
+      supmax01(idcum(i)) = supmax0(i)
+      asupmaxmin1(idcum(i)) = asupmaxmin(i)
     END DO
-  END DO
-
-  DO i = 1, ncum
-    sig1(idcum(i), nd) = sig(i, nd)
-  END DO
-
-
-  ! AC!        do 2100 j=1,ntra
-  ! AC!c oct3         do 2110 k=1,nl
-  ! AC!         do 2110 k=1,nd ! oct3
-  ! AC!          do 2120 i=1,ncum
-  ! AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
-  ! AC! 2120     continue
-  ! AC! 2110    continue
-  ! AC! 2100   continue
-
-  ! AC!
-  DO j = 1, nd
-    DO k = 1, nd
+   
+    DO k = 1, nl+1
       DO i = 1, ncum
-        phi1(idcum(i), k, j) = phi(i, k, j) !AC!
-        phi21(idcum(i), k, j) = phi2(i, k, j) !RomP
-        sigij1(idcum(i), k, j) = sigij(i, k, j) !RomP
-        elij1(idcum(i), k, j) = elij(i, k, j) !RomP
-        epmlmmm(idcum(i), k, j) = epmlmmm(i, k, j) !RomP+jyg
+        sig1(idcum(i), k) = sig(i, k)
+        w01(idcum(i), k) = w0(i, k)
+        ft1(idcum(i), k) = ft(i, k)
+        fq1(idcum(i), k) = fq(i, k)
+        fu1(idcum(i), k) = fu(i, k)
+        fv1(idcum(i), k) = fv(i, k)
+        ma1(idcum(i), k) = ma(i, k)
+        mip1(idcum(i), k) = mip(i, k)
+        vprecip1(idcum(i), k) = vprecip(i, k)
+        upwd1(idcum(i), k) = upwd(i, k)
+        dnwd1(idcum(i), k) = dnwd(i, k)
+        dnwd01(idcum(i), k) = dnwd0(i, k)
+        qcondc1(idcum(i), k) = qcondc(i, k)
+        tvp1(idcum(i), k) = tvp(i, k)
+        ftd1(idcum(i), k) = ftd(i, k)
+        fqd1(idcum(i), k) = fqd(i, k)
+        asupmax1(idcum(i), k) = asupmax(i, k)
+   
+        da1(idcum(i), k) = da(i, k) !AC!
+        mp1(idcum(i), k) = mp(i, k) !RomP
+        d1a1(idcum(i), k) = d1a(i, k) !RomP
+        dam1(idcum(i), k) = dam(i, k) !RomP
+        clw1(idcum(i), k) = clw(i, k) !RomP
+        evap1(idcum(i), k) = evap(i, k) !RomP
+        ep1(idcum(i), k) = ep(i, k) !RomP
+        eplamM1(idcum(i), k) = eplamM(i, k) !RomP+jyg
+        wdtrainA1(idcum(i), k) = wdtrainA(i, k) !RomP
+        wdtrainM1(idcum(i), k) = wdtrainM(i, k) !RomP
+        qtc1(idcum(i), k) = qtc(i, k)
+        sigt1(idcum(i), k) = sigt(i, k)
+   
       END DO
     END DO
-  END DO
-  ! AC!
-
-
-  ! do 2220 k2=1,nd
-  ! do 2210 k1=1,nd
-  ! do 2200 i=1,ncum
-  ! ment1(idcum(i),k1,k2) = ment(i,k1,k2)
-  ! sigij1(idcum(i),k1,k2) = sigij(i,k1,k2)
-  ! 2200      enddo
-  ! 2210     enddo
-  ! 2220    enddo
+   
+    ! AC!        do 2100 j=1,ntra
+    ! AC!c oct3         do 2110 k=1,nl
+    ! AC!         do 2110 k=1,nd ! oct3
+    ! AC!          do 2120 i=1,ncum
+    ! AC!            ftra1(idcum(i),k,j)=ftra(i,k,j)
+    ! AC! 2120     continue
+    ! AC! 2110    continue
+    ! AC! 2100   continue
+   
+    ! AC!
+!jyg<
+!  Essais pour gagner du temps en diminuant l'adressage indirect 
+!!    DO j = 1, nd
+!!      DO k = 1, nd
+!!        DO i = 1, ncum
+!!          phi1(idcum(i), k, j) = phi(i, k, j) !AC!
+!!          phi21(idcum(i), k, j) = phi2(i, k, j) !RomP
+!!          sigij1(idcum(i), k, j) = sigij(i, k, j) !RomP
+!!          elij1(idcum(i), k, j) = elij(i, k, j) !RomP
+!!          epmlmMm(idcum(i), k, j) = epmlmMm(i, k, j) !RomP+jyg
+!!        END DO
+!!      END DO
+!!    END DO
+      DO i = 1, ncum
+        jdcum=idcum(i)
+        phi1    (jdcum, 1:nl+1, 1:nl+1) = phi    (i, 1:nl+1, 1:nl+1)          !AC!
+        phi21   (jdcum, 1:nl+1, 1:nl+1) = phi2   (i, 1:nl+1, 1:nl+1)          !RomP
+        sigij1  (jdcum, 1:nl+1, 1:nl+1) = sigij  (i, 1:nl+1, 1:nl+1)          !RomP
+        elij1   (jdcum, 1:nl+1, 1:nl+1) = elij   (i, 1:nl+1, 1:nl+1)          !RomP
+        epmlmMm1(jdcum, 1:nl+1, 1:nl+1) = epmlmMm(i, 1:nl+1, 1:nl+1)          !RomP+jyg
+      END DO
+!>jyg
+    ! AC!
+   
+   
+    ! do 2220 k2=1,nd
+    ! do 2210 k1=1,nd
+    ! do 2200 i=1,ncum
+    ! ment1(idcum(i),k1,k2) = ment(i,k1,k2)
+    ! sigij1(idcum(i),k1,k2) = sigij(i,k1,k2)
+    ! 2200      enddo
+    ! 2210     enddo
+    ! 2220    enddo
+!
+!jyg<
+  ELSE  !(compress)
+!
+      sig1(:,nd) = sig(:,nd)
+      ptop21(:) = ptop2(:)
+      sigd1(:) = sigd(:)
+      precip1(:) = precip(:)
+      cbmf1(:) = cbmf(:)
+      plcl1(:) = plcl(:)
+      plfc1(:) = plfc(:)
+      wbeff1(:) = wbeff(:)
+      iflag1(:) = iflag(:)
+      kbas1(:) = kbas(:)
+      ktop1(:) = ktop(:)
+      wd1(:) = wd(:)
+      cape1(:) = cape(:)
+      cin1(:) = cin(:)
+      plim11(:) = plim1(:)
+      plim21(:) = plim2(:)
+      supmax01(:) = supmax0(:)
+      asupmaxmin1(:) = asupmaxmin(:)
+!
+      sig1(:, 1:nl+1) = sig(:, 1:nl+1)
+      w01(:, 1:nl+1) = w0(:, 1:nl+1)
+      ft1(:, 1:nl+1) = ft(:, 1:nl+1)
+      fq1(:, 1:nl+1) = fq(:, 1:nl+1)
+      fu1(:, 1:nl+1) = fu(:, 1:nl+1)
+      fv1(:, 1:nl+1) = fv(:, 1:nl+1)
+      ma1(:, 1:nl+1) = ma(:, 1:nl+1)
+      mip1(:, 1:nl+1) = mip(:, 1:nl+1)
+      vprecip1(:, 1:nl+1) = vprecip(:, 1:nl+1)
+      upwd1(:, 1:nl+1) = upwd(:, 1:nl+1)
+      dnwd1(:, 1:nl+1) = dnwd(:, 1:nl+1)
+      dnwd01(:, 1:nl+1) = dnwd0(:, 1:nl+1)
+      qcondc1(:, 1:nl+1) = qcondc(:, 1:nl+1)
+      tvp1(:, 1:nl+1) = tvp(:, 1:nl+1)
+      ftd1(:, 1:nl+1) = ftd(:, 1:nl+1)
+      fqd1(:, 1:nl+1) = fqd(:, 1:nl+1)
+      asupmax1(:, 1:nl+1) = asupmax(:, 1:nl+1)
+
+      da1(:, 1:nl+1) = da(:, 1:nl+1)              !AC!
+      mp1(:, 1:nl+1) = mp(:, 1:nl+1)              !RomP
+      d1a1(:, 1:nl+1) = d1a(:, 1:nl+1)            !RomP
+      dam1(:, 1:nl+1) = dam(:, 1:nl+1)            !RomP
+      clw1(:, 1:nl+1) = clw(:, 1:nl+1)            !RomP
+      evap1(:, 1:nl+1) = evap(:, 1:nl+1)          !RomP
+      ep1(:, 1:nl+1) = ep(:, 1:nl+1)              !RomP
+      eplamM1(:, 1:nl+1) = eplamM(:, 1:nl+1)       !RomP+jyg
+      wdtrainA1(:, 1:nl+1) = wdtrainA(:, 1:nl+1)  !RomP
+      wdtrainM1(:, 1:nl+1) = wdtrainM(:, 1:nl+1)  !RomP
+      qtc1(:, 1:nl+1) = qtc(:, 1:nl+1)
+      sigt1(:, 1:nl+1) = sigt(:, 1:nl+1)
+!
+      phi1    (:, 1:nl+1, 1:nl+1) = phi    (:, 1:nl+1, 1:nl+1)  !AC!
+      phi21   (:, 1:nl+1, 1:nl+1) = phi2   (:, 1:nl+1, 1:nl+1)  !RomP
+      sigij1  (:, 1:nl+1, 1:nl+1) = sigij  (:, 1:nl+1, 1:nl+1)  !RomP
+      elij1   (:, 1:nl+1, 1:nl+1) = elij   (:, 1:nl+1, 1:nl+1)  !RomP
+      epmlmMm1(:, 1:nl+1, 1:nl+1) = epmlmMm(:, 1:nl+1, 1:nl+1)  !RomP+jyg
+  ENDIF !(compress)
+!>jyg
 
   RETURN
Index: LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cv3p1_closure.F90	(revision 2298)
@@ -29,26 +29,29 @@
 
   ! input:
-  INTEGER ncum, nd, nloc
-  INTEGER icb(nloc), inb(nloc)
-  REAL pbase(nloc), plcl(nloc)
-  REAL p(nloc, nd), ph(nloc, nd+1)
-  REAL tv(nloc, nd), tvp(nloc, nd), buoy(nloc, nd)
-  REAL supmax(nloc, nd)
-  LOGICAL ok_inhib ! enable convection inhibition by dryness
-  REAL ale(nloc), alp(nloc)
-  REAL omega(nloc,nd)
+  INTEGER, INTENT (IN)                               :: ncum, nd, nloc
+  INTEGER, DIMENSION (nloc), INTENT (IN)             :: icb, inb
+  REAL, DIMENSION (nloc), INTENT (IN)                :: pbase, plcl
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: p
+  REAL, DIMENSION (nloc, nd+1), INTENT (IN)          :: ph
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: tv, tvp, buoy
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: supmax
+  LOGICAL, INTENT (IN)                               :: ok_inhib ! enable convection inhibition by dryness
+  REAL, DIMENSION (nloc), INTENT (IN)                :: ale, alp
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: omega
 
   ! input/output:
-  REAL sig(nloc, nd), w0(nloc, nd), ptop2(nloc)
+  REAL, DIMENSION (nloc, nd), INTENT (INOUT)         :: sig, w0
+  REAL, DIMENSION (nloc), INTENT (INOUT)             :: ptop2
 
   ! output:
-  REAL cape(nloc), cin(nloc)
-  REAL m(nloc, nd)
-  REAL plim1(nloc), plim2(nloc)
-  REAL asupmax(nloc, nd), supmax0(nloc)
-  REAL asupmaxmin(nloc)
-  REAL cbmf(nloc), plfc(nloc)
-  REAL wbeff(nloc)
-  INTEGER iflag(nloc)
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: cape, cin
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: m
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: plim1, plim2
+  REAL, DIMENSION (nloc, nd), INTENT (OUT)           :: asupmax
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: supmax0
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: asupmaxmin
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: cbmf, plfc
+  REAL, DIMENSION (nloc), INTENT (OUT)               :: wbeff
+  INTEGER, DIMENSION (nloc), INTENT (OUT)            :: iflag
 
   ! local variables:
@@ -91,5 +94,4 @@
 
 
-
   DO il = 1, ncum
     alp2(il) = max(alp(il), 1.E-5)
@@ -498,9 +500,8 @@
   IF (prt_level>=20) PRINT *, 'cv3p1_param apres cbmflim'
 
-  ! c 1.5 Compute cloud base mass flux given by Alp closure (Cbmf1), maximum
-  ! c     allowed mass flux (Cbmfmax) and final target mass flux (Cbmf)
-  ! c     Cbmf is set to zero if Cbmflim (the mass flux of elementary cloud)
-  ! is
-  ! --    exceedingly small.
+  ! 1.5 Compute cloud base mass flux given by Alp closure (Cbmf1), maximum
+  !     allowed mass flux (Cbmfmax) and final target mass flux (Cbmf)
+  !     Cbmf is set to zero if Cbmflim (the mass flux of elementary cloud)
+  !     is exceedingly small.
 
   DO il = 1, ncum
Index: LMDZ5/branches/testing/libf/phylmd/cv3param.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cv3param.h	(revision 2274)
+++ LMDZ5/branches/testing/libf/phylmd/cv3param.h	(revision 2298)
@@ -19,7 +19,5 @@
       real betad
 
-      COMMON /cv3param/  noff, minorig, nl, nlp, nlm &
-                      ,  sigdz, spfac &
-                      ,flag_epKEorig &
+      COMMON /cv3param/ sigdz, spfac &
                       ,pbcrit, ptcrit &
                       ,elcrit, tlcrit &
@@ -27,6 +25,9 @@
                       ,dtovsh, dpbase, dttrig &
                       ,dtcrit, tau, beta, alpha, alpha1 &
-                      ,flag_wb,wbmax &
-                      ,delta, betad
+                      ,wbmax &
+                      ,delta, betad  &
+                      ,flag_epKEorig &
+                      ,flag_wb &
+                      ,noff, minorig, nl, nlp, nlm
 !$OMP THREADPRIVATE(/cv3param/)
 
